#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BChoiceDlg.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif


BChoiceDlg::BChoiceDlg(int x,int y,int dx,int dy,char *q,char *b1,int *r,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int but_x=10;
	int but_dx;

	
	but_dx=get_text_width(b1,font)+10;
	b=new BButton(but_x,30,but_dx,12,b1,1);
	buttons.Add(b);
	but_x+=but_dx+10;

	b=new BButton(but_x,30,get_text_width("Cancel",font)+10,12,"Cancel",0);
	buttons.Add(b);

	query=q;
	result=r;
} /* BChoiceDlg::BChoiceDlg */ 


BChoiceDlg::BChoiceDlg(int x,int y,int dx,int dy,char *q,char *b1,char *b2,int *r,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int but_x=10;
	int but_dx;

	but_dx=get_text_width(b1,font)+10;
	b=new BButton(but_x,30,but_dx,12,b1,1);
	buttons.Add(b);
	but_x+=but_dx+10;
	
	but_dx=get_text_width(b2,font)+10;
	b=new BButton(but_x,30,but_dx,12,b2,2);
	buttons.Add(b);
	but_x+=but_dx+10;

	b=new BButton(but_x,30,get_text_width("Cancel",font)+10,12,"Cancel",0);
	buttons.Add(b);

	query=q;
	result=r;
} /* BChoiceDlg::BChoiceDlg */ 


BChoiceDlg::BChoiceDlg(int x,int y,int dx,int dy,char *q,char *b1,char *b2,char *b3,int *r,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;
	int but_x=10;
	int but_dx;

	but_dx=get_text_width(b1,font)+10;
	b=new BButton(but_x,30,but_dx,12,b1,1);
	buttons.Add(b);
	but_x+=but_dx+10;
	
	but_dx=get_text_width(b2,font)+10;
	b=new BButton(but_x,30,but_dx,12,b2,2);
	buttons.Add(b);
	but_x+=but_dx+10;

	but_dx=get_text_width(b3,font)+10;
	b=new BButton(but_x,30,but_dx,12,b3,3);
	buttons.Add(b);
	but_x+=but_dx+10;

	b=new BButton(but_x,30,get_text_width("Cancel",font)+10,12,"Cancel",0);
	buttons.Add(b);

	query=q;
	result=r;
} /* BChoiceDlg::BChoiceDlg */ 


BChoiceDlg::~BChoiceDlg()
{
} /* BChoiceDlg::BChoiceDlg */ 


void BChoiceDlg::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BChoiceDlg::contens_size */ 


void BChoiceDlg::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	print_centered(query,font,255,255,255,sfc,dx/2-stx,8-sty);
} /* BChoiceDlg::draw_contens */ 


bool BChoiceDlg::button_pressed(int ID)
{
	if (result!=0) *result=ID;
	return false;
} /* BChoiceDlg::button_pressed */ 


